Index: trunk/NEMO/OPA_SRC/restart.F90
===================================================================
--- trunk/NEMO/OPA_SRC/restart.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/restart.F90	(revision 508)
@@ -3,43 +3,88 @@
    !!                     ***  MODULE  restart  ***
    !! Ocean restart :  write the ocean restart file
-   !!=====================================================================
-
-   !!----------------------------------------------------------------------
-   !!   rst_write  : write of the restart file
-   !!   rst_read   : read the restart file
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !!======================================================================
+   !! History :        !  99-11  (M. Imbard)  Original code
+   !!             8.5  !  02-08  (G. Madec)  F90: Free form
+   !!             9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!             9.0  !  06-07  (S. Masson)  use IOM for restart
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   rst_opn    : open the ocean restart file
+   !!   rst_write  : write the ocean restart file
+   !!   rst_read   : read the ocean restart file
+   !!----------------------------------------------------------------------
    USE dom_oce         ! ocean space and time domain
    USE oce             ! ocean dynamics and tracers 
    USE phycst          ! physical constants
-   USE in_out_manager  ! I/O manager
    USE daymod          ! calendar
-   USE sol_oce         ! ocean elliptic solver
-   USE zdf_oce         ! ???
-   USE zdftke          ! turbulent kinetic energy scheme
    USE ice_oce         ! ice variables
    USE blk_oce         ! bulk variables
-   USE flx_oce         ! sea-ice/ocean forcings variables
-   USE dynspg_oce      ! free surface time splitting scheme variables
    USE cpl_oce, ONLY : lk_cpl              !
+   USE in_out_manager  ! I/O manager
+   USE iom             ! I/O module
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC rst_write  ! routine called by step.F90
-   PUBLIC rst_read   ! routine called by inidtr.F90
-
-   !! * Module variables
-   CHARACTER (len=48) ::   &
-      crestart = 'initial.nc'   ! restart file name
-   !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   PUBLIC   rst_opn    ! routine called by step module
+   PUBLIC   rst_write  ! routine called by step module
+   PUBLIC   rst_read   ! routine called by opa  module
+
+   LOGICAL, PUBLIC ::   lrst_oce         !: logical to control the oce restart write 
+   INTEGER, PUBLIC ::   nitrst           !: time step at which restart file should be written
+   INTEGER, PUBLIC ::   numror, numrow   !: logical unit for cean restart (read and write)
+
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 
 CONTAINS
+
+   SUBROUTINE rst_opn( kt )
+      !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE rst_opn  ***
+      !!                     
+      !! ** Purpose : + initialization (should be read in the namelist) of nitrst 
+      !!              + open the restart when we are one time step before nitrst
+      !!                   - restart header is defined when kt = nitrst-1
+      !!                   - restart data  are written when kt = nitrst
+      !!              + define lrst_oce to .TRUE. when we need to define or write the restart
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt     ! ocean time-step
+      !!
+      CHARACTER(LEN=20)   ::   clkt     ! ocean time-step deine as a character
+      CHARACTER(LEN=50)   ::   clname   ! ice output restart file name
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nit000 ) THEN   ! default initialization, to do: should be read in the namelist...
+         nitrst = nitend        ! to do: should be read in the namelist in a cleaver way...
+         lrst_oce = .FALSE.
+      ENDIF
+      
+      IF    ( kt == nitrst-1 .AND. lrst_oce         ) THEN
+         CALL ctl_stop( 'rst_opn: we cannot create an ocean restart at every time step' )
+         numrow = 0
+      ELSEIF( kt == nitrst-1 .OR.  nitend == nit000 ) THEN   ! beware if model runs only one time step
+         ! beware of the format used to write kt (default is i8.8, that should be large enough)
+         IF( nitrst > 1.0e9 ) THEN   
+            WRITE(clkt,*) nitrst
+         ELSE
+            WRITE(clkt,'(i8.8)') nitrst
+         ENDIF
+         ! create the file
+         IF(lwp) WRITE(numout,*)
+         clname = TRIM(cexper)//"_"//TRIM(ADJUSTL(clkt))//"_restart"
+         IF(lwp) WRITE(numout,*) '             open ocean restart.output NetCDF file: '//clname
+         CALL iom_open( clname, numrow, ldwrt = .TRUE. )
+         lrst_oce = .TRUE.
+      ENDIF
+      !
+   END SUBROUTINE rst_opn
+
 
 #if  ( defined key_mpp_mpi   ||   defined key_mpp_shmem ) && defined key_dimgout
@@ -66,153 +111,56 @@
       !! ** Purpose :   Write restart fields in NetCDF format
       !!
-      !! ** Method  :   Write in numwrs file each nstock time step in NetCDF
+      !! ** Method  :   Write in numrow when kt == nitrst in NetCDF
       !!      file, save fields which are necessary for restart
-      !!
-      !! History :
-      !!        !  99-11  (M. Imbard)  Original code
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form
-      !!   9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      USE ioipsl
-
-      !! * Arguments 
-      INTEGER, INTENT( in ) ::   kt         ! ocean time-step
-
-      !! * Local declarations
-      LOGICAL ::   llbon
-      CHARACTER (len=50) ::   clname, cln
-      INTEGER ::   ic, jc, itime
-      INTEGER ::   inumwrs
-      REAL(wp) ::   zdate0
-      REAL(wp), DIMENSION( 1) ::   zfice, zfblk   ! used only in case of ice & bulk
-      REAL(wp), DIMENSION(10) ::   zinfo(10)
-      REAL(wp), DIMENSION(jpi,jpj) :: ztab 
-#if defined key_agrif
-       Integer :: knum
-#endif
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'rst_wri : write restart.output NetCDF file'
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
-         zfice(1) = 1.e0   ;   zfblk(1) = 1.e0
-      ENDIF
-
-
-      IF( MOD( kt, nstock ) == 0 .OR. kt == nitend ) THEN
-         
-         ! 0. Initializations
-         ! ------------------
-
-         IF(lwp) WRITE(numout,*) ' '
-         IF(lwp) WRITE(numout,*) 'rst_write : write the restart file in NetCDF format ',   &
-                                              'at it= ',kt,' date= ',ndastp
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~'
-
-         ! Job informations 
-         zinfo(:) = 0.e0 
-         zinfo(1) = FLOAT( no        )   ! job number
-         zinfo(2) = FLOAT( kt        )   ! time-step
-         zinfo(3) = FLOAT( 2 - nsolv )   ! pcg solver
-         zinfo(4) = FLOAT( nsolv - 1 )   ! sor solver
-         IF( lk_zdftke ) THEN
-            zinfo(5) = 1.e0              ! TKE 
-         ELSE
-            zinfo(5) = 0.e0              ! no TKE 
-         ENDIF
-         zinfo(6) = FLOAT( ndastp )      ! date
-         zinfo(7) = adatrj               ! ???
-
-         ! delete the restart file if it exists 
-         INQUIRE( FILE=crestart, EXIST=llbon )
-         IF(llbon) THEN
-#if defined key_agrif
-       knum =Agrif_Get_Unit()
-            OPEN( UNIT=knum, FILE=crestart, STATUS='old' )
-            CLOSE( knum, STATUS='delete' )
-#else            
-            OPEN( UNIT=inumwrs, FILE=crestart, STATUS='old' )
-            CLOSE( inumwrs, STATUS='delete' )
-#endif
-         ENDIF
-
-         ! Name of the new restart file
-         ic     = 1
-         DO jc = 1, 16
-            IF( cexper(jc:jc) /= ' ' )   ic = jc
-         END DO
-         WRITE(cln,'("_",i4.4,i2.2,i2.2,"_restart")') nyear, nmonth, nday
-         clname = cexper(1:ic)//cln
-         ic = 1
-         DO jc = 1, 48
-            IF( clname(jc:jc) /= ' ' ) ic = jc
-         END DO
-         crestart = clname(1:ic)//".nc"
-         itime = 0
-         CALL ymds2ju( nyear, nmonth, nday, 0.e0, zdate0 )
-         CALL restini( 'NONE', jpi, jpj, glamt, gphit, jpk, gdept_0, clname,   &
-                        itime, zdate0, rdt*nstock ,inumwrs, domain_id=nidom )
-
-         CALL restput( inumwrs, 'info'   , 1  , 1  , 10 , 0, zinfo   )   ! restart informations
-         
-         CALL restput( inumwrs, 'ub'     , jpi, jpj, jpk, 0, ub      )   ! prognostic variables
-         CALL restput( inumwrs, 'vb'     , jpi, jpj, jpk, 0, vb      )
-         CALL restput( inumwrs, 'tb'     , jpi, jpj, jpk, 0, tb      )
-         CALL restput( inumwrs, 'sb'     , jpi, jpj, jpk, 0, sb      )
-         CALL restput( inumwrs, 'rotb'   , jpi, jpj, jpk, 0, rotb    )
-         CALL restput( inumwrs, 'hdivb'  , jpi, jpj, jpk, 0, hdivb   )
-         CALL restput( inumwrs, 'un'     , jpi, jpj, jpk, 0, un      )
-         CALL restput( inumwrs, 'vn'     , jpi, jpj, jpk, 0, vn      )
-         CALL restput( inumwrs, 'tn'     , jpi, jpj, jpk, 0, tn      )
-         CALL restput( inumwrs, 'sn'     , jpi, jpj, jpk, 0, sn      )
-         CALL restput( inumwrs, 'rotn'   , jpi, jpj, jpk, 0, rotn    )
-         CALL restput( inumwrs, 'hdivn'  , jpi, jpj, jpk, 0, hdivn   )
-
-         ztab(:,:) = gcx(1:jpi,1:jpj)
-         CALL restput( inumwrs, 'gcx'    , jpi, jpj, 1  , 0, ztab    )   ! Read elliptic solver arrays
-         ztab(:,:) = gcxb(1:jpi,1:jpj)
-         CALL restput( inumwrs, 'gcxb'   , jpi, jpj, 1  , 0, ztab    )
-# if defined key_dynspg_rl
-         CALL restput( inumwrs, 'bsfb'   , jpi, jpj, 1  , 0, bsfb    )   ! Rigid-lid formulation (bsf)
-         CALL restput( inumwrs, 'bsfn'   , jpi, jpj, 1  , 0, bsfn    )
-         CALL restput( inumwrs, 'bsfd'   , jpi, jpj, 1  , 0, bsfd    )
-# else
-         CALL restput( inumwrs, 'sshb'   , jpi, jpj, 1  , 0, sshb    )   ! free surface formulation (ssh)
-         CALL restput( inumwrs, 'sshn'   , jpi, jpj, 1  , 0, sshn    )
-#  if defined key_dynspg_ts
-         CALL restput( inumwrs, 'sshb_b' , jpi, jpj, 1  , 0, sshb_b  )   ! free surface formulation (ssh)
-         CALL restput( inumwrs, 'sshn_b' , jpi, jpj, 1  , 0, sshn_b  )   ! issued from barotropic loop
-         CALL restput( inumwrs, 'un_b'   , jpi, jpj, 1  , 0, un_b    )   ! horizontal transports
-         CALL restput( inumwrs, 'vn_b'   , jpi, jpj, 1  , 0, vn_b    )   ! issued from barotropic loop
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step
+      !!----------------------------------------------------------------------
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'rst_write : write ocean NetCDF restart file  kt =', kt,' date= ', ndastp
+         WRITE(numout,*) '~~~~~~~~~'
+      ENDIF
+      
+      ! calendar control
+      CALL iom_rstput( kt, nitrst, numrow, 'kt'     , REAL( kt    , wp) )   ! time-step 
+      CALL iom_rstput( kt, nitrst, numrow, 'ndastp' , REAL( ndastp, wp) )   ! date
+      CALL iom_rstput( kt, nitrst, numrow, 'adatrj' ,       adatrj      )   ! number of elapsed days since
+      !                                                                     ! the begining of the run [s]
+
+      ! prognostic variables
+      CALL iom_rstput( kt, nitrst, numrow, 'ub'     , ub      )   
+      CALL iom_rstput( kt, nitrst, numrow, 'vb'     , vb      )
+      CALL iom_rstput( kt, nitrst, numrow, 'tb'     , tb      )
+      CALL iom_rstput( kt, nitrst, numrow, 'sb'     , sb      )
+      CALL iom_rstput( kt, nitrst, numrow, 'rotb'   , rotb    )
+      CALL iom_rstput( kt, nitrst, numrow, 'hdivb'  , hdivb   )
+      CALL iom_rstput( kt, nitrst, numrow, 'un'     , un      )
+      CALL iom_rstput( kt, nitrst, numrow, 'vn'     , vn      )
+      CALL iom_rstput( kt, nitrst, numrow, 'tn'     , tn      )
+      CALL iom_rstput( kt, nitrst, numrow, 'sn'     , sn      )
+      CALL iom_rstput( kt, nitrst, numrow, 'rotn'   , rotn    )
+      CALL iom_rstput( kt, nitrst, numrow, 'hdivn'  , hdivn   )
+
+# if defined key_ice_lim        
+      CALL iom_rstput( kt, nitrst, numrow, 'nfice'  , REAL( nfice, wp) )   !  ice computation frequency
+      CALL iom_rstput( kt, nitrst, numrow, 'sst_io' , sst_io  )
+      CALL iom_rstput( kt, nitrst, numrow, 'sss_io' , sss_io  )
+      CALL iom_rstput( kt, nitrst, numrow, 'u_io'   , u_io    )
+      CALL iom_rstput( kt, nitrst, numrow, 'v_io'   , v_io    )
+#  if defined key_coupled
+      CALL iom_rstput( kt, nitrst, numrow, 'alb_ice', alb_ice )
 #  endif
 # endif
-# if defined key_zdftke   ||   defined key_esopa
-         IF( lk_zdftke ) THEN
-            CALL restput( inumwrs, 'en'     , jpi, jpj, jpk, 0, en      )   ! TKE arrays
-         ENDIF
-# endif
-# if defined key_ice_lim
-         zfice(1) = FLOAT( nfice )                                      ! Louvain La Neuve Sea Ice Model
-         CALL restput( inumwrs, 'nfice'  ,   1,   1, 1  , 0, zfice   )
-         CALL restput( inumwrs, 'sst_io' , jpi, jpj, 1  , 0, sst_io  )
-         CALL restput( inumwrs, 'sss_io' , jpi, jpj, 1  , 0, sss_io  )
-         CALL restput( inumwrs, 'u_io'   , jpi, jpj, 1  , 0, u_io    )
-         CALL restput( inumwrs, 'v_io'   , jpi, jpj, 1  , 0, v_io    )
-# if defined key_coupled
-         CALL restput( inumwrs, 'alb_ice', jpi, jpj, 1  , 0, alb_ice )
-# endif
-# endif
 # if defined key_flx_bulk_monthly || defined key_flx_bulk_daily
-         zfblk(1) = FLOAT( nfbulk )                                 ! Bulk
-         CALL restput( inumwrs, 'nfbulk' ,   1,   1, 1  , 0, zfblk   )
-         CALL restput( inumwrs, 'gsst'   , jpi, jpj, 1  , 0, gsst    )
-# endif
-
-         CALL restclo( inumwrs )                                         ! close the restart file
-         
-      ENDIF
-
+      CALL iom_rstput( kt, nitrst, numrow, 'nfbulk' , REAL( nfbulk, wp) )   !  bulk computation frequency
+      CALL iom_rstput( kt, nitrst, numrow, 'gsst'   , gsst    )
+# endif
+
+      IF( kt == nitrst ) THEN
+         CALL iom_close( numrow )     ! close the restart file (only at last time step)
+         lrst_oce = .FALSE.
+      ENDIF
+      !
    END SUBROUTINE rst_write
 
@@ -246,154 +194,126 @@
       !!       nrstdt = 2  the duration of the experiment in days (adatrj)
       !!                    has been stored in the restart file.
-      !!
-      !! History :
-      !!        !  99-05  (M. Imbard)  Original code
-      !!   8.5  !  02-09  (G. Madec)  F90: Free form
-      !!   9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      USE iom
-
-      !! * Local declarations
-      INTEGER  ::   &
-         inum                 ! temporary logical unit
-      REAL(wp), DIMENSION(1, 1, 10)  ::   zinfo
-      REAL(wp), DIMENSION(1, 1, 1)   ::   zzz 
-      INTEGER  ::   ios
-#   if defined key_ice_lim
+      !!----------------------------------------------------------------------
+      REAL(wp) ::   zcoef, zkt, zndastp, znfice, znfbulk
+# if defined key_ice_lim
       INTEGER  ::   ji, jj
-#   endif
-      !!----------------------------------------------------------------------
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'rst_read : read the NetCDF restart file'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~'
-
-      IF(lwp) WRITE(numout,*) ' Info on the present job : '
-      IF(lwp) WRITE(numout,*) '   job number          : ', no
-      IF(lwp) WRITE(numout,*) '   time-step           : ', nit000
-      IF(lwp) WRITE(numout,*) '   solver type         : ', nsolv
-      IF( lk_zdftke ) THEN
-         IF(lwp) WRITE(numout,*) '   tke option          : 1 '
-      ELSE
-         IF(lwp) WRITE(numout,*) '   tke option          : 0 '
-      ENDIF
-      IF(lwp) WRITE(numout,*) '   date ndastp         : ', ndastp
-      IF(lwp) WRITE(numout,*)
-
-      ! Time domain : restart
-      ! -------------------------
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' *** restart option'
-      SELECT CASE ( nrstdt )
-      CASE ( 0 ) 
-         IF(lwp) WRITE(numout,*) ' nrstdt = 0 no control of nit000'
-      CASE ( 1 ) 
-         IF(lwp) WRITE(numout,*) ' nrstdt = 1 we control the date of nit000'
-      CASE ( 2 )
-         IF(lwp) WRITE(numout,*) ' nrstdt = 2 the date adatrj is read in restart file'
-      CASE DEFAULT
-         IF(lwp) WRITE(numout,*) '  ===>>>> nrstdt not equal 0, 1 or 2 : no control of the date'
-         IF(lwp) WRITE(numout,*) ' =======                   ========='
-      END SELECT
-
-      CALL iom_open ( 'restart', inum )
-      
-      CALL iom_get ( inum, jpdom_unknown, 'info', zinfo )
-      
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' Info on the restart file read : '
-      IF(lwp) WRITE(numout,*) '   job number          : ', NINT( zinfo(1, 1, 1) )
-      IF(lwp) WRITE(numout,*) '   time-step           : ', NINT( zinfo(1, 1, 2) )
-      IF(lwp) WRITE(numout,*) '   solver type         : ', NINT( zinfo(1, 1, 4) ) + 1
-      IF(lwp) WRITE(numout,*) '   tke option          : ', NINT( zinfo(1, 1, 5) )
-      IF(lwp) WRITE(numout,*) '   date ndastp         : ', NINT( zinfo(1, 1, 6) )
-      IF(lwp) WRITE(numout,*)
-
+# endif
+      !!----------------------------------------------------------------------
+
+      IF(lwp) THEN                                             ! Contol prints
+         WRITE(numout,*)
+         WRITE(numout,*) 'rst_read : read oce NetCDF restart file'
+         WRITE(numout,*) '~~~~~~~~'
+         
+         WRITE(numout,*) ' *** Info on the present job : '
+         WRITE(numout,*) '   time-step           : ', nit000
+!!$         WRITE(numout,*) '   solver type         : ', nsolv
+!!$         IF( lk_zdftke ) THEN
+!!$            WRITE(numout,*) '   tke option          : 1 '
+!!$         ELSE
+!!$            WRITE(numout,*) '   tke option          : 0 '
+!!$         ENDIF
+         WRITE(numout,*) '   date ndastp         : ', ndastp
+         WRITE(numout,*)
+         WRITE(numout,*) ' *** restart option'
+         SELECT CASE ( nrstdt )
+         CASE ( 0 ) 
+            WRITE(numout,*) ' nrstdt = 0 no control of nit000'
+         CASE ( 1 ) 
+            WRITE(numout,*) ' nrstdt = 1 we control the date of nit000'
+         CASE ( 2 )
+            WRITE(numout,*) ' nrstdt = 2 the date adatrj is read in restart file'
+         CASE DEFAULT
+            WRITE(numout,*) '  ===>>>> nrstdt not equal 0, 1 or 2 : no control of the date'
+            WRITE(numout,*) '  =======                  ========='
+         END SELECT
+         WRITE(numout,*)
+      ENDIF
+
+      CALL iom_open( 'restart', numror )                       ! Open
+
+      ! Calendar informations
+      CALL iom_get( numror, 'kt'    , zkt     )   ! time-step 
+      CALL iom_get( numror, 'ndastp', zndastp )   ! date
+      ! Additional contol prints
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' *** Info on the restart file read : '
+         WRITE(numout,*) '   time-step           : ', NINT( zkt )
+!!$         WRITE(numout,*) '   solver type         : ', +++
+!!$         WRITE(numout,*) '   tke option          : ', +++
+         WRITE(numout,*) '   date ndastp         : ', NINT( zndastp )
+         WRITE(numout,*)
+      ENDIF
       ! Control of date
-      IF( nit000 - NINT( zinfo(1, 1, 2) )  /= 1 .AND. nrstdt /= 0 ) &
+      IF( nit000 - NINT( zkt )  /= 1 .AND. nrstdt /= 0 ) &
            & CALL ctl_stop( ' ===>>>> : problem with nit000 for the restart', &
            & ' verify the restart file or rerun with nrstdt = 0 (namelist)' )
-
       ! re-initialisation of  adatrj0
-      adatrj0 =  ( FLOAT( nit000-1 ) * rdttra(1) ) / rday
-
+      adatrj0 = ( REAL( nit000-1, wp ) * rdttra(1) ) / rday
       IF ( nrstdt == 2 ) THEN
 !                             by default ndatsp has been set to ndate0 in dom_nam
 !                             ndate0 has been read in the namelist (standard OPA 8)
 !                             here when nrstdt=2 we keep the  final date of previous run
-        ndastp = NINT( zinfo(1, 1, 6) )
-        adatrj0 =  zinfo(1, 1, 7)
-      ENDIF
-
-      CALL iom_get( inum, jpdom_local, 'ub'   , ub    )   ! Read prognostic variables
-      CALL iom_get( inum, jpdom_local, 'vb'   , vb    )
-      CALL iom_get( inum, jpdom_local, 'tb'   , tb    )
-      CALL iom_get( inum, jpdom_local, 'sb'   , sb    )
-      CALL iom_get( inum, jpdom_local, 'rotb' , rotb  )
-      CALL iom_get( inum, jpdom_local, 'hdivb', hdivb )
-      CALL iom_get( inum, jpdom_local, 'un'   , un    )
-      CALL iom_get( inum, jpdom_local, 'vn'   , vn    )
-      CALL iom_get( inum, jpdom_local, 'tn'   , tn    )
-      CALL iom_get( inum, jpdom_local, 'sn'   , sn    )
-      CALL iom_get( inum, jpdom_local, 'rotn' , rotn  )
-      CALL iom_get( inum, jpdom_local, 'hdivn', hdivn )
-! Caution : extrahallow 
-! gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
-      CALL iom_get( inum, jpdom_local, 'gcx' , gcx (1:jpi,1:jpj) )
-      CALL iom_get( inum, jpdom_local, 'gcxb', gcxb(1:jpi,1:jpj) )     ! Read elliptic solver arrays
-# if defined key_dynspg_rl
-      CALL iom_get( inum, jpdom_local, 'bsfb', bsfb )     ! Rigid-lid formulation (bsf)
-      CALL iom_get( inum, jpdom_local, 'bsfn', bsfn )
-      CALL iom_get( inum, jpdom_local, 'bsfd', bsfd )
-# else
-      CALL iom_get( inum, jpdom_local, 'sshb', sshb )     ! free surface formulation (ssh)
-      CALL iom_get( inum, jpdom_local, 'sshn', sshn )
-#  if defined key_dynspg_ts
-      CALL iom_get( inum, jpdom_local, 'sshb_b', sshb_b ) ! free surface formulation (ssh)
-      CALL iom_get( inum, jpdom_local, 'sshn_b', sshn_b ) ! issued from barotropic loop
-      CALL iom_get( inum, jpdom_local, 'un_b'  , un_b )   ! horizontal transports
-      CALL iom_get( inum, jpdom_local, 'vn_b'  , vn_b )   ! issued from barotropic loop
-#  endif
-# endif
-# if defined key_zdftke   ||   defined key_esopa
-      IF( lk_zdftke ) THEN
-         IF( NINT( zinfo(1, 1, 5) ) == 1 ) THEN                                ! Read tke arrays
-            CALL iom_get( inum, jpdom_local, 'en', en )
-            ln_rstke = .FALSE.
-         ELSE
-            IF(lwp) WRITE(numout,*) ' ===>>>> : the previous restart file did not used  tke scheme'
-            IF(lwp) WRITE(numout,*) ' =======                ======='
-            nrstdt = 2
-            ln_rstke = .TRUE.
-         ENDIF
-      ENDIF
-# endif
+         ndastp = NINT( zndastp )
+        CALL iom_get( numror, 'adatrj', adatrj )   ! number of elapsed days since the begining of last run
+      ENDIF
+
+      !                                                       ! Read prognostic variables
+      CALL iom_get( numror, jpdom_local, 'ub'   , ub    )        ! before i-component velocity
+      CALL iom_get( numror, jpdom_local, 'vb'   , vb    )        ! before j-component velocity
+      CALL iom_get( numror, jpdom_local, 'tb'   , tb    )        ! before temperature
+      CALL iom_get( numror, jpdom_local, 'sb'   , sb    )        ! before salinity
+      CALL iom_get( numror, jpdom_local, 'rotb' , rotb  )        ! before curl
+      CALL iom_get( numror, jpdom_local, 'hdivb', hdivb )        ! before horizontal divergence
+      CALL iom_get( numror, jpdom_local, 'un'   , un    )        ! now    i-component velocity
+      CALL iom_get( numror, jpdom_local, 'vn'   , vn    )        ! now    j-component velocity
+      CALL iom_get( numror, jpdom_local, 'tn'   , tn    )        ! now    temperature
+      CALL iom_get( numror, jpdom_local, 'sn'   , sn    )        ! now    salinity
+      CALL iom_get( numror, jpdom_local, 'rotn' , rotn  )        ! now    curl
+      CALL iom_get( numror, jpdom_local, 'hdivn', hdivn )        ! now    horizontal divergence
+
+
+      IF( neuler == 0 ) THEN                                  ! Euler restart (neuler=0)
+         tb   (:,:,:) = tn   (:,:,:)                             ! all before fields set to now field values
+         sb   (:,:,:) = sn   (:,:,:)
+         ub   (:,:,:) = un   (:,:,:)
+         vb   (:,:,:) = vn   (:,:,:)
+         rotb (:,:,:) = rotn (:,:,:)
+         hdivb(:,:,:) = hdivn(:,:,:)
+      ENDIF
+
+      !!sm: TO BE MOVED IN NEW SURFACE MODULE...
+
 # if defined key_ice_lim
       ! Louvain La Neuve Sea Ice Model
-      ios = iom_varid( inum, 'nfice' )
-      IF( ios > 0 ) then 
-         CALL iom_get( inum, jpdom_unknown, 'nfice' , zzz )
-         zinfo(1, 1, 8) = zzz(1, 1, 1)
-         CALL iom_get( inum, jpdom_local, 'sst_io', sst_io )
-         CALL iom_get( inum, jpdom_local, 'sss_io', sss_io )
-         CALL iom_get( inum, jpdom_local, 'u_io'  , u_io )
-         CALL iom_get( inum, jpdom_local, 'v_io'  , v_io )
+      IF( iom_varid( numror, 'nfice' ) > 0 ) then 
+         CALL iom_get( numror             , 'nfice'  , znfice  )   ! ice computation frequency
+         CALL iom_get( numror, jpdom_local, 'sst_io' , sst_io  )
+         CALL iom_get( numror, jpdom_local, 'sss_io' , sss_io  )
+         CALL iom_get( numror, jpdom_local, 'u_io'   , u_io    )
+         CALL iom_get( numror, jpdom_local, 'v_io'   , v_io    )
 #if defined key_coupled
-         CALL iom_get( inum, jpdom_local, 'alb_ice', alb_ice )
+         CALL iom_get( numror, jpdom_local, 'alb_ice', alb_ice )
 #endif
-      ENDIF
-      IF( zinfo(1, 1, 8) /= FLOAT(nfice) .OR. ios == 0 ) THEN
+         IF( znfice /= REAL( nfice, wp ) ) THEN      ! if nfice changed between 2 runs
+            zcoef = REAL( nfice-1, wp ) / znfice
+            sst_io(:,:) = zcoef * sst_io(:,:)
+            sss_io(:,:) = zcoef * sss_io(:,:)
+            u_io  (:,:) = zcoef * u_io  (:,:)
+            v_io  (:,:) = zcoef * v_io  (:,:)
+         ENDIF
+      ELSE
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'rst_read :  LLN sea Ice Model => Ice initialization'
          IF(lwp) WRITE(numout,*)
-         sst_io(:,:) = ( nfice-1 )*( tn(:,:,1) + rt0 )          !!bug a explanation is needed here!
-         sss_io(:,:) = ( nfice-1 )*  sn(:,:,1)
+         zcoef = REAL( nfice-1, wp )
+         sst_io(:,:) = zcoef *( tn(:,:,1) + rt0 )          !!bug a explanation is needed here!
+         sss_io(:,:) = zcoef *  sn(:,:,1)
+         zcoef = 0.5 * REAL( nfice-1, wp )
          DO jj = 2, jpj
-            DO ji = 2, jpi
-               u_io(ji,jj) = ( nfice-1 ) * 0.5 * ( un(ji-1,jj  ,1) + un(ji-1,jj-1,1) )
-               v_io(ji,jj) = ( nfice-1 ) * 0.5 * ( vn(ji  ,jj-1,1) + vn(ji-1,jj-1,1) )
+            DO ji = fs_2, jpi   ! vector opt.
+               u_io(ji,jj) = zcoef * ( un(ji-1,jj  ,1) + un(ji-1,jj-1,1) )
+               v_io(ji,jj) = zcoef * ( vn(ji  ,jj-1,1) + vn(ji-1,jj-1,1) )
             END DO
          END DO
@@ -405,41 +325,25 @@
 # if defined key_flx_bulk_monthly || defined key_flx_bulk_daily
       ! Louvain La Neuve Sea Ice Model
-      ios = iom_varid( inum, 'nfbulk' )
-      IF( ios > 0 ) then 
-         CALL iom_get( inum, jpdom_unknown, 'nfbulk' , zzz )
-         CALL iom_get( inum, jpdom_local, 'gsst' , gsst )
-         zinfo(1, 1, 9) = zzz(1, 1, 1)
-      ENDIF
-      IF( zinfo(1, 1, 9) /= FLOAT(nfbulk) .OR. ios == 0 ) THEN
+      IF( iom_varid( numror, 'nfbulk' ) > 0 ) THEN 
+         CALL iom_get( numror             , 'nfbulk', znfbulk )   ! bulk computation frequency
+         CALL iom_get( numror, jpdom_local, 'gsst'  , gsst    )
+         IF( znfbulk /= REAL(nfbulk, wp) ) THEN      ! if you change nfbulk between 2 runs
+            zcoef = REAL( nfbulk-1, wp ) / znfbulk
+            gsst(:,:) = zcoef * gsst(:,:)
+         ENDIF
+      ELSE
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'rst_read :  LLN sea Ice Model => Ice initialization'
          IF(lwp) WRITE(numout,*)
-         gsst(:,:) = 0.
-         gsst(:,:) = gsst(:,:) + ( nfbulk-1 )*( tn(:,:,1) + rt0 )
+         gsst(:,:) = REAL( nfbulk - 1, wp )*( tn(:,:,1) + rt0 )
       ENDIF
 # endif
       
-      CALL iom_close( inum )
-
-  ! In case of restart with neuler = 0 then put all before fields = to now fields
-    IF ( neuler == 0 ) THEN
-      tb(:,:,:)=tn(:,:,:)
-      sb(:,:,:)=sn(:,:,:)
-      ub(:,:,:)=un(:,:,:)
-      vb(:,:,:)=vn(:,:,:)
-      rotb(:,:,:)=rotn(:,:,:)
-      hdivb(:,:,:)=hdivn(:,:,:)
-#if defined key_dynspg_rl
-    ! rigid lid
-      bsfb(:,:)=bsfn(:,:)
-#else
-    ! free surface formulation (eta)
-      sshb(:,:)=sshn(:,:)
+      !!sm: end of TO BE MOVED IN NEW SURFACE MODULE...
+      !
+   END SUBROUTINE rst_read
+
 #endif
-    ENDIF
-
-   END SUBROUTINE rst_read
-
-#endif
+
    !!=====================================================================
 END MODULE restart
